diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/interference-helper.h ns-3.44/src/wifi/model/interference-helper.h
--- ns-3.43/src/wifi/model/interference-helper.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/interference-helper.h	2025-03-09 16:55:49.791372500 -0700
@@ -21,9 +21,9 @@
 class ErrorRateModel;
 
 /**
- * \ingroup wifi
- * \brief handles interference calculations
- * \brief signal event for a PPDU.
+ * @ingroup wifi
+ * @brief handles interference calculations
+ * @brief signal event for a PPDU.
  */
 class Event : public SimpleRefCount<Event>
 {
@@ -32,69 +32,69 @@
      * Create an Event with the given parameters. Note that <i>rxPower</i> will
      * be moved into this object.
      *
-     * \param ppdu the PPDU
-     * \param duration duration of the PPDU
-     * \param rxPower the received power per band (W)
+     * @param ppdu the PPDU
+     * @param duration duration of the PPDU
+     * @param rxPower the received power per band (W)
      */
     Event(Ptr<const WifiPpdu> ppdu, Time duration, RxPowerWattPerChannelBand&& rxPower);
 
     /**
      * Return the PPDU.
      *
-     * \return the PPDU
+     * @return the PPDU
      */
     Ptr<const WifiPpdu> GetPpdu() const;
     /**
      * Return the start time of the signal.
      *
-     * \return the start time of the signal
+     * @return the start time of the signal
      */
     Time GetStartTime() const;
     /**
      * Return the end time of the signal.
      *
-     * \return the end time of the signal
+     * @return the end time of the signal
      */
     Time GetEndTime() const;
     /**
      * Return the duration of the signal.
      *
-     * \return the duration of the signal
+     * @return the duration of the signal
      */
     Time GetDuration() const;
     /**
      * Return the total received power.
      *
-     * \return the total received power
+     * @return the total received power
      */
     Watt_u GetRxPower() const;
     /**
      * Return the received power for a given band.
      *
-     * \param band the band for which the power should be returned
-     * \return the received power for a given band
+     * @param band the band for which the power should be returned
+     * @return the received power for a given band
      */
     Watt_u GetRxPower(const WifiSpectrumBandInfo& band) const;
     /**
      * Return the received power (W) for all bands.
      *
-     * \return the received power (W) for all bands.
+     * @return the received power (W) for all bands.
      */
     const RxPowerWattPerChannelBand& GetRxPowerPerBand() const;
     /**
      * Update the received power (W) for all bands, i.e. add up the received power
      * to the current received power, for each band.
      *
-     * \param rxPower the received power (W) for all bands.
+     * @param rxPower the received power (W) for all bands.
      */
     void UpdateRxPowerW(const RxPowerWattPerChannelBand& rxPower);
     /**
      * Update the PPDU that initially generated the event.
      * This is needed to have the PPDU holding the correct TXVECTOR
-     * upon reception of multiple signals carring the same content
+     * upon reception of multiple signals carrying the same content
      * but over different channel width (typically non-HT duplicates).
      *
-     * \param ppdu the new PPDU to use for this event.
+     * @param ppdu the new PPDU to use for this event.
      */
     void UpdatePpdu(Ptr<const WifiPpdu> ppdu);
 
@@ -106,17 +106,17 @@
 };
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the stream
- * \param event the event
- * \returns a reference to the stream
+ * @param os the stream
+ * @param event the event
+ * @returns a reference to the stream
  */
 std::ostream& operator<<(std::ostream& os, const Event& event);
 
 /**
- * \ingroup wifi
- * \brief handles interference calculations
+ * @ingroup wifi
+ * @brief handles interference calculations
  */
 class InterferenceHelper : public Object
 {
@@ -125,29 +125,29 @@
     ~InterferenceHelper() override;
 
     /**
-     * \brief Get the type ID.
-     * \return the object TypeId
+     * @brief Get the type ID.
+     * @return the object TypeId
      */
     static TypeId GetTypeId();
 
     /**
      * Add a frequency band.
      *
-     * \param band the band to be added
+     * @param band the band to be added
      */
     void AddBand(const WifiSpectrumBandInfo& band);
 
     /**
      * Remove a frequency band.
      *
-     * \param band the band to be removed
+     * @param band the band to be removed
      */
     void RemoveBand(const WifiSpectrumBandInfo& band);
 
     /**
      * Check whether bands are already tracked by this interference helper.
      *
-     * \return true if bands are tracked by this interference helper, false otherwise
+     * @return true if bands are tracked by this interference helper, false otherwise
      */
     bool HasBands() const;
 
@@ -155,8 +155,8 @@
      * Update the frequency bands that belongs to a given frequency range when the spectrum model is
      * changed.
      *
-     * \param bands the bands to be added in the new spectrum model
-     * \param freqRange the frequency range the bands belong to
+     * @param bands the bands to be added in the new spectrum model
+     * @param freqRange the frequency range the bands belong to
      */
     void UpdateBands(const std::vector<WifiSpectrumBandInfo>& bands,
                      const FrequencyRange& freqRange);
@@ -164,35 +164,35 @@
     /**
      * Set the noise figure.
      *
-     * \param value noise figure in linear scale
+     * @param value noise figure in linear scale
      */
     void SetNoiseFigure(double value);
     /**
      * Set the error rate model for this interference helper.
      *
-     * \param rate Error rate model
+     * @param rate Error rate model
      */
     void SetErrorRateModel(const Ptr<ErrorRateModel> rate);
 
     /**
      * Return the error rate model.
      *
-     * \return Error rate model
+     * @return Error rate model
      */
     Ptr<ErrorRateModel> GetErrorRateModel() const;
     /**
      * Set the number of RX antennas in the receiver corresponding to this
      * interference helper.
      *
-     * \param rx the number of RX antennas
+     * @param rx the number of RX antennas
      */
     void SetNumberOfReceiveAntennas(uint8_t rx);
 
     /**
-     * \param energy the minimum energy requested
-     * \param band identify the requested band
+     * @param energy the minimum energy requested
+     * @param band identify the requested band
      *
-     * \returns the expected amount of time the observed
+     * @returns the expected amount of time the observed
      *          energy on the medium for a given band will
      *          be higher than the requested threshold.
      */
@@ -201,14 +201,14 @@
     /**
      * Add the PPDU-related signal to interference helper.
      *
-     * \param ppdu the PPDU
-     * \param duration the PPDU duration
-     * \param rxPower received power per band (W)
-     * \param freqRange the frequency range in which the received signal is detected
-     * \param isStartHePortionRxing flag whether the event corresponds to the start of the HE
+     * @param ppdu the PPDU
+     * @param duration the PPDU duration
+     * @param rxPower received power per band (W)
+     * @param freqRange the frequency range in which the received signal is detected
+     * @param isStartHePortionRxing flag whether the event corresponds to the start of the HE
      * portion reception (only used for MU)
      *
-     * \return Event
+     * @return Event
      */
     Ptr<Event> Add(Ptr<const WifiPpdu> ppdu,
                    Time duration,
@@ -218,9 +218,9 @@
 
     /**
      * Add a non-Wifi signal to interference helper.
-     * \param duration the duration of the signal
-     * \param rxPower received power per band (W)
-     * \param freqRange the frequency range in which the received signal is detected
+     * @param duration the duration of the signal
+     * @param rxPower received power per band (W)
+     * @param freqRange the frequency range in which the received signal is detected
      */
     void AddForeignSignal(Time duration,
                           RxPowerWattPerChannelBand& rxPower,
@@ -232,14 +232,14 @@
      * reception success/failure evaluation, while hiding aggregation details from
      * this class.
      *
-     * \param event the event corresponding to the first time the corresponding PPDU arrives
-     * \param channelWidth the channel width used to transmit the PSDU
-     * \param band identify the band used by the PSDU
-     * \param staId the station ID of the PSDU (only used for MU)
-     * \param relativeMpduStartStop the time window (pair of start and end times) of PHY payload to
+     * @param event the event corresponding to the first time the corresponding PPDU arrives
+     * @param channelWidth the channel width used to transmit the PSDU
+     * @param band identify the band used by the PSDU
+     * @param staId the station ID of the PSDU (only used for MU)
+     * @param relativeMpduStartStop the time window (pair of start and end times) of PHY payload to
      * focus on
      *
-     * \return struct of SNR and PER (with PER being evaluated over the provided time window)
+     * @return struct of SNR and PER (with PER being evaluated over the provided time window)
      */
     PhyEntity::SnrPer CalculatePayloadSnrPer(Ptr<Event> event,
                                              MHz_u channelWidth,
@@ -249,12 +249,12 @@
     /**
      * Calculate the SNIR for the event (starting from now until the event end).
      *
-     * \param event the event corresponding to the first time the corresponding PPDU arrives
-     * \param channelWidth the channel width
-     * \param nss the number of spatial streams
-     * \param band identify the band used by the PSDU
+     * @param event the event corresponding to the first time the corresponding PPDU arrives
+     * @param channelWidth the channel width
+     * @param nss the number of spatial streams
+     * @param band identify the band used by the PSDU
      *
-     * \return the SNR for the PPDU in linear scale
+     * @return the SNR for the PPDU in linear scale
      */
     double CalculateSnr(Ptr<Event> event,
                         MHz_u channelWidth,
@@ -264,12 +264,12 @@
      * Calculate the SNIR at the start of the PHY header and accumulate
      * all SNIR changes in the SNIR vector.
      *
-     * \param event the event corresponding to the first time the corresponding PPDU arrives
-     * \param channelWidth the channel width for header measurement
-     * \param band identify the band used by the PSDU
-     * \param header the PHY header to consider
+     * @param event the event corresponding to the first time the corresponding PPDU arrives
+     * @param channelWidth the channel width for header measurement
+     * @param band identify the band used by the PSDU
+     * @param header the PHY header to consider
      *
-     * \return struct of SNR and PER
+     * @return struct of SNR and PER
      */
     PhyEntity::SnrPer CalculatePhyHeaderSnrPer(Ptr<Event> event,
                                                MHz_u channelWidth,
@@ -278,22 +278,22 @@
 
     /**
      * Notify that RX has started.
-     * \param freqRange the frequency range in which the received signal event is detected
+     * @param freqRange the frequency range in which the received signal event is detected
      */
     void NotifyRxStart(const FrequencyRange& freqRange);
     /**
      * Notify that RX has ended.
      *
-     * \param endTime the end time of the signal
-     * \param freqRange the frequency range in which the received signal event was detected
+     * @param endTime the end time of the signal
+     * @param freqRange the frequency range in which the received signal event was detected
      */
     void NotifyRxEnd(Time endTime, const FrequencyRange& freqRange);
 
     /**
      * Update event to scale its received power (W) per band.
      *
-     * \param event the event to be updated
-     * \param rxPower the received power (W) per band to be added to the current event
+     * @param event the event to be updated
+     * @param rxPower the received power (W) per band to be added to the current event
      */
     void UpdateEvent(Ptr<Event> event, const RxPowerWattPerChannelBand& rxPower);
 
@@ -303,12 +303,12 @@
     /**
      * Calculate SNR (linear ratio) from the given signal power and noise+interference power.
      *
-     * \param signal signal power
-     * \param noiseInterference noise and interference power
-     * \param channelWidth signal width
-     * \param nss the number of spatial streams
+     * @param signal signal power
+     * @param noiseInterference noise and interference power
+     * @param channelWidth signal width
+     * @param nss the number of spatial streams
      *
-     * \return SNR in linear scale
+     * @return SNR in linear scale
      */
     double CalculateSnr(Watt_u signal,
                         Watt_u noiseInterference,
@@ -318,13 +318,13 @@
      * Calculate the success rate of the chunk given the SINR, duration, and TXVECTOR.
      * The duration and TXVECTOR are used to calculate how many bits are present in the chunk.
      *
-     * \param snir the SINR
-     * \param duration the duration of the chunk
-     * \param mode the WifiMode
-     * \param txVector the TXVECTOR
-     * \param field the PPDU field to which the chunk belongs to
+     * @param snir the SINR
+     * @param duration the duration of the chunk
+     * @param mode the WifiMode
+     * @param txVector the TXVECTOR
+     * @param field the PPDU field to which the chunk belongs to
      *
-     * \return the success rate
+     * @return the success rate
      */
     double CalculateChunkSuccessRate(double snir,
                                      Time duration,
@@ -336,12 +336,12 @@
      * The duration and TXVECTOR are used to calculate how many bits are present in the payload
      * chunk.
      *
-     * \param snir the SINR
-     * \param duration the duration of the chunk
-     * \param txVector the TXVECTOR
-     * \param staId the station ID of the PSDU (only used for MU)
+     * @param snir the SINR
+     * @param duration the duration of the chunk
+     * @param txVector the TXVECTOR
+     * @param staId the station ID of the PSDU (only used for MU)
      *
-     * \return the success rate
+     * @return the success rate
      */
     double CalculatePayloadChunkSuccessRate(double snir,
                                             Time duration,
@@ -361,27 +361,27 @@
         /**
          * Create a NiChange at the given time and the amount of NI change.
          *
-         * \param power the power
-         * \param event causes this NI change
+         * @param power the power
+         * @param event causes this NI change
          */
         NiChange(Watt_u power, Ptr<Event> event);
         ~NiChange();
         /**
          * Return the power
          *
-         * \return the power
+         * @return the power
          */
         Watt_u GetPower() const;
         /**
          * Add a given amount of power.
          *
-         * \param power the power to be added to the existing value
+         * @param power the power to be added to the existing value
          */
         void AddPower(Watt_u power);
         /**
          * Return the event causes the corresponding NI change
          *
-         * \return the event
+         * @return the event
          */
         Ptr<Event> GetEvent() const;
 
@@ -411,17 +411,17 @@
     /**
      * Check whether a given band is tracked by this interference helper.
      *
-     * \param band the band to be checked
-     * \return true if the band is already tracked by this interference helper, false otherwise
+     * @param band the band to be checked
+     * @return true if the band is already tracked by this interference helper, false otherwise
      */
     bool HasBand(const WifiSpectrumBandInfo& band) const;
 
     /**
      * Check whether a given band belongs to a given frequency range.
      *
-     * \param band the band to be checked
-     * \param freqRange the frequency range to check whether the band belong to
-     * \return true if the band belongs to the frequency range, false otherwise
+     * @param band the band to be checked
+     * @param freqRange the frequency range to check whether the band belong to
+     * @return true if the band belongs to the frequency range, false otherwise
      */
     bool IsBandInFrequencyRange(const WifiSpectrumBandInfo& band,
                                 const FrequencyRange& freqRange) const;
@@ -429,9 +429,9 @@
     /**
      * Append the given Event.
      *
-     * \param event the event to be appended
-     * \param freqRange the frequency range in which the received signal event is detected
-     * \param isStartHePortionRxing flag whether event corresponds to the start of the HE portion
+     * @param event the event to be appended
+     * @param freqRange the frequency range in which the received signal event is detected
+     * @param isStartHePortionRxing flag whether event corresponds to the start of the HE portion
      * reception (only used for MU)
      */
     void AppendEvent(Ptr<Event> event, const FrequencyRange& freqRange, bool isStartHePortionRxing);
@@ -439,11 +439,11 @@
     /**
      * Calculate noise and interference power.
      *
-     * \param event the event
-     * \param nis the NiChanges
-     * \param band the band
+     * @param event the event
+     * @param nis the NiChanges
+     * @param band the band
      *
-     * \return noise and interference power
+     * @return noise and interference power
      */
     Watt_u CalculateNoiseInterferenceW(Ptr<Event> event,
                                        NiChangesPerBand& nis,
@@ -453,10 +453,10 @@
      * Calculate power of all other events preceding a given event that belong to the same MU-MIMO
      * transmission.
      *
-     * \param event the event
-     * \param band the band
+     * @param event the event
+     * @param band the band
      *
-     * \return the power of all other events preceding the event that belong to the same MU-MIMO
+     * @return the power of all other events preceding the event that belong to the same MU-MIMO
      * transmission
      */
     Watt_u CalculateMuMimoPowerW(Ptr<const Event> event, const WifiSpectrumBandInfo& band) const;
@@ -466,14 +466,14 @@
      * window (thus enabling per MPDU PER information). The PHY payload can be divided into
      * multiple chunks (e.g. due to interference from other transmissions).
      *
-     * \param event the event
-     * \param channelWidth the channel width used to transmit the PSDU
-     * \param nis the NiChanges
-     * \param band identify the band used by the PSDU
-     * \param staId the station ID of the PSDU (only used for MU)
-     * \param window time window (pair of start and end times) of PHY payload to focus on
+     * @param event the event
+     * @param channelWidth the channel width used to transmit the PSDU
+     * @param nis the NiChanges
+     * @param band identify the band used by the PSDU
+     * @param staId the station ID of the PSDU (only used for MU)
+     * @param window time window (pair of start and end times) of PHY payload to focus on
      *
-     * \return the error rate of the payload
+     * @return the error rate of the payload
      */
     double CalculatePayloadPer(Ptr<const Event> event,
                                MHz_u channelWidth,
@@ -485,13 +485,13 @@
      * Calculate the error rate of the PHY header. The PHY header
      * can be divided into multiple chunks (e.g. due to interference from other transmissions).
      *
-     * \param event the event
-     * \param nis the NiChanges
-     * \param channelWidth the channel width for header measurement
-     * \param band the band
-     * \param header the PHY header to consider
+     * @param event the event
+     * @param nis the NiChanges
+     * @param channelWidth the channel width for header measurement
+     * @param band the band
+     * @param header the PHY header to consider
      *
-     * \return the error rate of the HT PHY header
+     * @return the error rate of the HT PHY header
      */
     double CalculatePhyHeaderPer(Ptr<const Event> event,
                                  NiChangesPerBand* nis,
@@ -501,13 +501,13 @@
     /**
      * Calculate the success rate of the PHY header sections for the provided event.
      *
-     * \param event the event
-     * \param nis the NiChanges
-     * \param channelWidth the channel width for header measurement
-     * \param band the band
-     * \param phyHeaderSections the map of PHY header sections (\see PhyEntity::PhyHeaderSections)
+     * @param event the event
+     * @param nis the NiChanges
+     * @param channelWidth the channel width for header measurement
+     * @param band the band
+     * @param phyHeaderSections the map of PHY header sections (\see PhyEntity::PhyHeaderSections)
      *
-     * \return the success rate of the PHY header sections
+     * @return the success rate of the PHY header sections
      */
     double CalculatePhyHeaderSectionPsr(Ptr<const Event> event,
                                         NiChangesPerBand* nis,
@@ -523,17 +523,17 @@
     /**
      * Returns an iterator to the first NiChange that is later than moment
      *
-     * \param moment time to check from
-     * \param niIt iterator of the band to check
-     * \returns an iterator to the list of NiChanges
+     * @param moment time to check from
+     * @param niIt iterator of the band to check
+     * @returns an iterator to the list of NiChanges
      */
     NiChanges::iterator GetNextPosition(Time moment, NiChangesPerBand::iterator niIt);
     /**
      * Returns an iterator to the last NiChange that is before than moment
      *
-     * \param moment time to check from
-     * \param niIt iterator of the band to check
-     * \returns an iterator to the list of NiChanges
+     * @param moment time to check from
+     * @param niIt iterator of the band to check
+     * @returns an iterator to the list of NiChanges
      */
     NiChanges::iterator GetPreviousPosition(Time moment, NiChangesPerBand::iterator niIt);
 
@@ -541,10 +541,10 @@
      * Add NiChange to the list at the appropriate position and
      * return the iterator of the new event.
      *
-     * \param moment time to check from
-     * \param change the NiChange to add
-     * \param niIt iterator of the band to check
-     * \returns the iterator of the new event
+     * @param moment time to check from
+     * @param change the NiChange to add
+     * @param niIt iterator of the band to check
+     * @returns the iterator of the new event
      */
     NiChanges::iterator AddNiChangeEvent(Time moment,
                                          NiChange change,
@@ -554,10 +554,10 @@
      * Return whether another event is a MU-MIMO event that belongs to the same transmission and to
      * the same RU.
      *
-     * \param currentEvent the current event that is being inspected
-     * \param otherEvent the other event to compare against
+     * @param currentEvent the current event that is being inspected
+     * @param otherEvent the other event to compare against
      *
-     * \return whether both events belong to the same transmission and to the same RU
+     * @return whether both events belong to the same transmission and to the same RU
      */
     bool IsSameMuMimoTransmission(Ptr<const Event> currentEvent, Ptr<const Event> otherEvent) const;
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/mac-rx-middle.cc ns-3.44/src/wifi/model/mac-rx-middle.cc
--- ns-3.43/src/wifi/model/mac-rx-middle.cc	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/mac-rx-middle.cc	2025-03-09 16:55:49.791372500 -0700
@@ -50,7 +50,7 @@
     /**
      * Check if we are de-fragmenting packets.
      *
-     * \return true if we are de-fragmenting packets,
+     * @return true if we are de-fragmenting packets,
      *         false otherwise
      */
     bool IsDeFragmenting() const
@@ -62,7 +62,7 @@
      * We have received a first fragmented packet.
      * We start the deframentation by saving the first fragment.
      *
-     * \param packet the first fragmented packet
+     * @param packet the first fragmented packet
      */
     void AccumulateFirstFragment(Ptr<const Packet> packet)
     {
@@ -77,9 +77,9 @@
      * We re-construct the packet from the fragments we saved
      * and return the full packet.
      *
-     * \param packet the last fragment
+     * @param packet the last fragment
      *
-     * \return the fully reconstructed packet
+     * @return the fully reconstructed packet
      */
     Ptr<Packet> AccumulateLastFragment(Ptr<const Packet> packet)
     {
@@ -99,7 +99,7 @@
      * We received a fragmented packet (not first and not last).
      * We simply save it into our internal list.
      *
-     * \param packet the received fragment
+     * @param packet the received fragment
      */
     void AccumulateFragment(Ptr<const Packet> packet)
     {
@@ -111,9 +111,9 @@
      * Check if the sequence control (i.e. fragment number) is
      * in order.
      *
-     * \param sequenceControl the raw sequence control
+     * @param sequenceControl the raw sequence control
      *
-     * \return true if the sequence control is in order,
+     * @return true if the sequence control is in order,
      *         false otherwise
      */
     bool IsNextFragment(uint16_t sequenceControl) const
@@ -125,7 +125,7 @@
     /**
      * Return the last sequence control we received.
      *
-     * \return the last sequence control
+     * @return the last sequence control
      */
     uint16_t GetLastSequenceControl() const
     {
@@ -135,7 +135,7 @@
     /**
      * Set the last sequence control we received.
      *
-     * \param sequenceControl the last sequence control we received
+     * @param sequenceControl the last sequence control we received
      */
     void SetSequenceControl(uint16_t sequenceControl)
     {
@@ -161,17 +161,28 @@
 }
 
 OriginatorRxStatus&
-MacRxMiddle::Lookup(const WifiMacHeader& hdr)
+MacRxMiddle::Lookup(Ptr<const WifiMpdu> mpdu)
 {
-    NS_LOG_FUNCTION(hdr);
+    NS_LOG_FUNCTION(*mpdu);
+    const auto& hdr = mpdu->GetOriginal()->GetHeader();
     const auto source = hdr.GetAddr2();
-    if (hdr.IsQosData() && !source.IsGroup())
+    const auto dest = hdr.GetAddr1();
+    if (hdr.IsQosData() && !dest.IsGroup())
     {
-        /* only for QoS data non-broadcast frames */
+        /* only for QoS data unicast frames */
         const auto key = std::make_pair(source, hdr.GetQosTid());
         auto [it, inserted] = m_qosOriginatorStatus.try_emplace(key);
         return it->second;
     }
+    else if (hdr.IsQosData() && dest.IsGroup())
+    {
+        /* for QoS data groupcast frames: use the (nonconcealed) group address as key */
+        const auto groupAddress =
+            hdr.IsQosAmsdu() ? mpdu->begin()->second.GetDestinationAddr() : hdr.GetAddr1();
+        const auto key = std::make_pair(groupAddress, hdr.GetQosTid());
+        auto [it, inserted] = m_qosOriginatorStatus.insert({key, {}});
+        return it->second;
+    }
     /* - management frames
      * - QoS data broadcast frames
      * - non-QoS data frames
@@ -256,7 +267,7 @@
     const auto& hdr = mpdu->GetOriginal()->GetHeader();
     NS_ASSERT(hdr.IsData() || hdr.IsMgt());
 
-    auto& originator = Lookup(hdr);
+    auto& originator = Lookup(mpdu);
     /**
      * The check below is really unneeded because it can fail in a lot of
      * normal cases. Specifically, it is possible for sequence numbers to
@@ -287,10 +298,7 @@
     }
     NS_LOG_DEBUG("forwarding data from=" << hdr.GetAddr2() << ", seq=" << hdr.GetSequenceNumber()
                                          << ", frag=" << +hdr.GetFragmentNumber());
-    if (!hdr.GetAddr1().IsGroup())
-    {
-        originator.SetSequenceControl(hdr.GetSequenceControl());
-    }
+    originator.SetSequenceControl(hdr.GetSequenceControl());
     if (aggregate == mpdu->GetPacket())
     {
         m_callback(mpdu, linkId);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/mac-rx-middle.h ns-3.44/src/wifi/model/mac-rx-middle.h
--- ns-3.43/src/wifi/model/mac-rx-middle.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/mac-rx-middle.h	2025-03-09 16:55:49.791372500 -0700
@@ -24,7 +24,7 @@
 class WifiMpdu;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * This class handles duplicate detection and recomposition of fragments.
  */
@@ -42,15 +42,15 @@
     /**
      * Set a callback to forward the packet up.
      *
-     * \param callback the callback to set
+     * @param callback the callback to set
      */
     void SetForwardCallback(ForwardUpCallback callback);
 
     /**
      * Receive an MPDU on the given link.
      *
-     * \param mpdu the MPDU
-     * \param linkId the ID of the given link
+     * @param mpdu the MPDU
+     * @param linkId the ID of the given link
      */
     void Receive(Ptr<const WifiMpdu> mpdu, uint8_t linkId);
 
@@ -59,22 +59,23 @@
     friend class MacRxMiddleTest;
     /**
      * Look up for OriginatorRxStatus associated with the sender address
-     * (by looking at ADDR2 field in the header).
+     * (by looking at ADDR2 field in the header) for unicast. For groupcast,
+     * the (nonconcealed) group address is used instead.
      * The method creates a new OriginatorRxStatus if one is not already presented.
      *
-     * \param hdr the MAC header
+     * @param mpdu the received MPDU
      *
-     * \return OriginatorRxStatus
+     * @return OriginatorRxStatus
      */
-    OriginatorRxStatus& Lookup(const WifiMacHeader& hdr);
+    OriginatorRxStatus& Lookup(Ptr<const WifiMpdu> mpdu);
     /**
      * Check if we have already received the packet from the sender before
      * (by looking at the sequence control field).
      *
-     * \param hdr the MAC header
-     * \param originator the packet originator status
+     * @param hdr the MAC header
+     * @param originator the packet originator status
      *
-     * \return true if we already received the packet previously,
+     * @return true if we already received the packet previously,
      *         false otherwise
      */
     bool IsDuplicate(const WifiMacHeader& hdr, const OriginatorRxStatus& originator) const;
@@ -86,11 +87,11 @@
      * If the packet is the last fragment, the method tries to re-construct the full packet
      * and return the packet if success.
      *
-     * \param packet the packet
-     * \param hdr the MAC header
-     * \param originator the packet originator status
+     * @param packet the packet
+     * @param hdr the MAC header
+     * @param originator the packet originator status
      *
-     * \return a packet if the packet is successfully reassembled (or not a fragment),
+     * @return a packet if the packet is successfully reassembled (or not a fragment),
      *         0 if we failed to reassemble the packet (e.g. missing fragments/out-of-order).
      */
     Ptr<const Packet> HandleFragments(Ptr<const Packet> packet,
